import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:shared_preferences/shared_preferences.dart';
import 'package:syncfusion_flutter_gauges/gauges.dart';
import 'package:xcommonwidgets/xcommonwidgets.dart';
import 'package:xfxbase/xfxbase.dart';
import 'package:xtoolspackage/xtoolspackage.dart';

import '../XTabItem.dart';
import 'XAppData_Base.dart';
import 'XArea.dart';

class XMainPage_Base<T> extends StatefulWidget {
  XMainPage_Base(this.appState, this.xAppUI, {Key? key, this.title, this.logOUT_Active = true}) : super(key: key);
  String? title;
  bool? logOUT_Active;
  late XAppDataBase appState;
  late XApp xAppUI;

  @override
  XMainPage_BaseState<T> createState() => XMainPage_BaseState<T>();
}

class XMainPage_BaseState<T> extends State<XMainPage_Base<T>> with TickerProviderStateMixin {
  GlobalKey<ScaffoldState> scaffoldKey = GlobalKey<ScaffoldState>();
  late TabController? tabController;
  bool menuPinned = true;
  bool syncWithServer = false;
  @override
  void initState() {
    tabController = getTabController();

    super.initState();
  }

  TabController getTabController() {
    return TabController(length: widget.appState.li_XAree.length, vsync: this);
  }

  updateTabController() {
//    tabController = TabController(length: widget.li_XAree!.length, vsync: this);
    tabController = TabController(length: widget.appState.li_XAree.length, vsync: this);

    setState(() {
      print(tabController!.index.toString());
      tabController!.index = widget.appState.li_XAree.firstWhere((element) => element.key_Area == widget.appState.area_Active.key_Area).idx_Area;
      print(tabController!.index.toString());
    });
  }

  @override
  void dispose() {
    tabController!.dispose();
    super.dispose();
  }

  signOut() {
    SharedPreferences.getInstance().then((prefs) {
      prefs.clear();
    });
    Navigator.pushNamed(context, widget.appState.PgName_Login);
  }

  Future<bool> warnLogOff(BuildContext context) async {
    var rval = await showDialog<bool>(
        context: context,
        builder: (c) => AlertDialog(
              title: Text('Attenzione', textAlign: TextAlign.center, style: TextStyle(color: Colors.yellow)),
              content: Text('Sei sicuro di disconnetterti?'),
              actions: [
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.green), onPressed: () => Navigator.pop(c, true), child: Text('Si')),
                TextButton(style: TextButton.styleFrom(foregroundColor: Colors.red), onPressed: () => Navigator.pop(c, false), child: Text('No')),
              ],
            ));
    return rval ?? false;
  }

  @override
  Widget build(BuildContext context) {
    // return Consumer<T>(builder: (context, appState, _) {
    // menuPinned = (MediaQuery.of(context).size.width > XUtils.widthMin_Layout);

    return _buildPageLayout(context);
    // });
  }

  int lastTabIdx = -1;
  checkActive_Area(XMenuItem item) {
    var x = widget.appState.li_XAree.firstWhereOrNull((element) => element.key_Area == item.key);
    if (x != null) {
      widget.appState.area_Active = x;
    } else {
      lastTabIdx++;
      var xclArea = XArea(
        item.key,
        lastTabIdx,
        widget.appState.xApp.getWidget_FormMenuItem(item),
        color_Area: item.color_BTN,
        imageIcon_Area: item.image_Icon_BTN,
        label_Area: item.label,
        icon_Area: item.icon_BTN,
        color_AppBar: item.label_Color,
      );

      widget.appState.li_XAree.add(xclArea);
      widget.appState.area_Active = xclArea;
    }
    scaffoldKey.currentState!.closeDrawer();

    setState(() {
      MediaQuery.of(context).size.width < XUtils.widthMin_Layout
          ? (menuPinned = false)
          : menuPinned
              ? (scaffoldKey.currentState!.closeDrawer())
              : (menuPinned = false);
    });
  }

  getWidget_Area(XMenuItem item) {
    return Container();
  }

  KforScale_UI_edit() async {
    double _currentValue = (widget.appState.xApp.KforScale * 100).round().toDouble();
    double _minValue = 70;
    double _maxValue = 200;
    double _firstMarkerSize = 10;
    // String _annotationValue = '100';
    var res = await showDialog<bool?>(
        context: context,
        builder: (context) {
          return StatefulBuilder(builder: (context, setState) {
            double width = MediaQuery.of(context).size.width;

            //Da modificare per fare i font
            void handlePointerValueChanged(double value) {
              setState(() {
                _currentValue = value.round().toDouble();
              });
            }

            /// Pointer dragging is canceled when dragging pointer value is less than 7.
            void handlePointerValueChanging(ValueChangingArgs args) {
              if (args.value < _minValue || args.value > _maxValue) {
                args.cancel = true;
              }
            }

            return Container(
                margin: EdgeInsets.symmetric(horizontal: 20),
                child: XAlertDialog(
                    colorBackGround: Colors.grey[900],
                    height: MediaQuery.of(context).size.height / 2,
                    title_Text: "Scegli la tua grandezza del testo:",
                    title_Style: XStyles.xStyleText(fontSize: 18 * (_currentValue / 100) / widget.appState.xApp.KforScale),
                    content_insetPadding: EdgeInsets.all(0),
                    btnYES_label: "Salva",
                    btnNO_label: "Annulla",
                    child: Column(children: <Widget>[
                      Expanded(
                        flex: 7,
                        child: SfRadialGauge(axes: <RadialAxis>[
                          RadialAxis(
                            minimum: _minValue, maximum: _maxValue,
                            axisLineStyle: const AxisLineStyle(thickness: 0.2, thicknessUnit: GaugeSizeUnit.factor),
                            showTicks: false,
                            showLastLabel: true,
                            //style delle tacchette interne
                            axisLabelStyle: GaugeTextStyle(color: XColors.foregroundLight, fontSize: 18),
                            onAxisTapped: handlePointerValueChanged,
                            pointers: <GaugePointer>[
                              //streiscia da tappare e fare lo slide
                              RangePointer(
                                value: _currentValue,
                                onValueChanged: handlePointerValueChanged,
                                onValueChangeEnd: handlePointerValueChanged,
                                onValueChanging: handlePointerValueChanging,
                                enableDragging: true,
                                width: 0.2,
                                sizeUnit: GaugeSizeUnit.factor,
                              ),
                              //Pallino bianco dentro la striscia da tappare
                              MarkerPointer(
                                value: _currentValue,
                                color: Colors.white,
                                markerHeight: _firstMarkerSize,
                                markerWidth: _firstMarkerSize,
                                markerType: MarkerType.circle,
                              ),
                            ],
                            //Percentuale interna allo slider
                            annotations: <GaugeAnnotation>[
                              GaugeAnnotation(
                                  widget: Row(
                                    mainAxisSize: MainAxisSize.min,
                                    children: <Widget>[Text('${_currentValue.toInt()} %', style: XStyles.xStyTextForSubDescr())],
                                  ),
                                  positionFactor: 0.13,
                                  angle: 0)
                            ],
                          )
                        ]),
                      ),
                      //Slider orizzontale sotto alla chart
                      Expanded(
                          flex: 3,
                          child: SizedBox(
                            width: width - 50,
                            child: Slider(
                              min: _minValue,
                              max: _maxValue,
                              activeColor: const Color(0xFF02AAB0),
                              inactiveColor: const Color(0xFF00CDAC),
                              onChanged: handlePointerValueChanged,
                              value: _currentValue,
                            ),
                          )),
                    ]),
                    btnYES_OnPressed: () {
                      Navigator.pop(context, true);
                    },
                    btnNO_OnPressed: () {
                      Navigator.pop(context, false);
                    }));
          });
        });
    if (res != null && res) {
      setState(() {
        widget.appState.xApp.KforScale = _currentValue / 100;
      });
      var prefs = await SharedPreferences.getInstance();
      prefs.setString("fontSize", widget.appState.xApp.KforScale.toString());
    }
  }

  Future syncronizeDataFromServer() async {}

  xBuilder_XMenu(Function() tabController, Function() onPinned, bool pinned_Value) {
    return XfxMenu(
      widget.appState.xApp.liXMenus, tabController,
      KforScale_UI_edit,
      logOut_Visible: widget.logOUT_Active,
      functOnSync: syncWithServer == false
          ? () async {
              setState(() {
                syncWithServer = true;
              });
              await syncronizeDataFromServer();
              setState(() {
                syncWithServer = false;
              });
              XAlertDialog.alertClose(context, titleText: "Aggiornati con successo i dati dal server", titleStyle: XStyles.xStyTextForSubLabel(XColors.warning));
            }
          : null,
      title: widget.title,
      xApp: widget.xAppUI,
      padding: EdgeInsets.symmetric(vertical: 10),
      logOut_OnTap: () async {
        var x = await warnLogOff(context);
        if (x) {
          Navigator.pop(context);
          Navigator.pop(context);
        }
      },
      title_Style: XStyles.xStyTextForLabel(Colors.white),
      menu_BackGroundColor: Colors.grey[900],
      onPressed_PinnedBTN: () {
        if (widget.appState.li_XAree.isEmpty) {
        } else {
          onPinned();
        }
      },
      pinned_Value: pinned_Value,
      syncWithServer: syncWithServer,
      onPressed_MenuItem: (i) => checkActive_Area(i),
      // nameApp: Text(sex.app_Name, style: XStyles.xStyTextForLabel()),
    );
  }

  _buildPageLayout(BuildContext context) {
    return WillPopScope(
        ////////////////
        onWillPop: () async {
          scaffoldKey.currentState!.openDrawer();
          return false;
        },
        /////////////////////
        child: Scaffold(
          backgroundColor: Colors.black,
          key: scaffoldKey,
          appBar: null,

          /// X AREA CONTAINER
          body: Container(
              margin: EdgeInsets.only(top: MediaQuery.of(context).size.height < 500 ? 40 : 0),
              child: Row(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  MediaQuery.of(context).size.width < XUtils.widthMin_Layout
                      ? Container()
                      : (menuPinned.not()
                          ? XBtnbase(
                              label: "M\nE\nN\nU",
                              width: 30,
                              decoration: BoxDecoration(color: Colors.grey[800], border: Border.all(color: Colors.white, width: 2)),
                              height: MediaQuery.of(context).size.height,
                              label_Color: Colors.white,
                              onPressed: () {
                                scaffoldKey.currentState!.openDrawer();
                              },
                            )
                          : Container()),
                  menuPinned
                      ? xBuilder_XMenu(updateTabController, () {
                          if (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) {
                            setState(() {
                              menuPinned = false;
                            });
                          } else {
                            setState(() {
                              menuPinned = !menuPinned;
                            });
                          }
                          scaffoldKey.currentState!.closeDrawer();
                        }, menuPinned)
                      : Container(),
                  SizedBox(width: MediaQuery.of(context).size.width < XUtils.widthMin_Layout ? 0 : 10),
                  Expanded(
                      flex: 15,
                      child: syncWithServer
                          ? XStatefulWidgetBase.LoaderIndicator(syncWithServer, label: "...caricamento dei dati...")
                          : (widget.appState.li_XAree.length < 2)
                              ? (widget.appState.li_XAree.isNotEmpty)
                                  ? widget.appState.li_XAree.firstWhere((element) => element.key_Area == widget.appState.area_Active.key_Area).widget_Area ?? Container()
                                  : Container()
                              : MediaQuery.of(context).size.width < XUtils.widthMin_Layout
                                  ? widget.appState.area_Active.widget_Area ?? Container()
                                  : XfxArea(
                                      tabController: tabController,
                                      xApp: widget.appState,
                                      margin_Horizontal: 0,
                                      tapOnTab: (idx) {
                                        widget.appState.area_Active = widget.appState.li_XAree.firstWhere((element) => element.idx_Area == idx);
                                      },
                                      tabs_BackGroundColor: Colors.transparent,
                                      title_Visible: false,
                                      bottomBar_Visible: false,
                                      numberOfTabs: widget.appState.li_XAree.length,
                                      isScrollableTabs: false,
                                      children: widget.appState.li_XAree.map((x) {
                                        return x.widget_Area ?? Container();
                                      }).toList(),
                                      tabs: widget.appState.li_XAree
                                          .map((e) => XTabItem(
                                                e.idx_Area,
                                                e.key_Area,
                                                e.label_Area ?? "No Label",
                                                image_Icon: e.imageIcon_Area,
                                                icon: e.icon_Area ?? Icons.warning,
                                                color_backGroundTab: Colors.grey[900],
                                                color_backGroundTab_Activate: e.color_AppBar!.withAlpha(40),
                                                labelColor_Disabled: XColors.foregroundLight,
                                                labelColor_Active: e.color_AppBar,
                                                iconColor_Active: e.color_AppBar,
                                                iconColor_Disabled: XColors.foregroundLight,
                                              ))
                                          .toList(),
                                    )),
                ],
              )),
          ///////////////////// MENU

          drawer: menuPinned.not()
              ? xBuilder_XMenu(updateTabController, () {
                  if (MediaQuery.of(context).size.width < XUtils.widthMin_Layout) {
                    setState(() {
                      menuPinned = false;
                    });
                  } else {
                    setState(() {
                      menuPinned = !menuPinned;
                    });
                  }
                  scaffoldKey.currentState!.closeDrawer();
                }, menuPinned)
              : null,
        ));
  }
}
